# Python compatibility:
from __future__ import absolute_import

# Zope:
from DateTime import DateTime
from Products.CMFCore.utils import getToolByName

# visaplan:
from visaplan.plone.base import BrowserView, Interface, implements


class IServiceTemp(Interface):

    pass


class Browser(BrowserView):

    implements(IServiceTemp)

    def __call__(self):
        """
        temp folder cleanup

        Delete everything in the temporary folder
        (currently: as returned by @@temp/getTempFolder)
        which is

        - older than two days,
        - still untitled and
        - has an auto-generated id
        """
        context = self.context

        portal = getToolByName(context, 'portal_url').getPortalObject()
        sm = portal.getAdapter('securitymanager')
        sm(userId='system')
        sm.setNew()

        temp = portal.getBrowser('temp')
        folder = temp.getTempFolder()
        pu = getToolByName(context, 'plone_utils')
        now = DateTime() - 2  # not *now* but two days ago ...

        for id, object_ in folder.ZopeFind(obj=folder):
            if pu.isIDAutoGenerated(id) and object_.created() < now and not object_.Title():
                object_.restrictedTraverse('@@plone_lock_operations').force_unlock(redirect=False)
                folder.manage_delObjects(ids=[id])

        sm.setOld()

        return True
